#ifndef TASK_BEEP_H
#define TASK_BEEP_H

#include <stdint.h>
#include <stdbool.h>

// Hlasitost (pokud používáš, nebo můžeš ignorovat)
#define BEEP_VOLUME_PERCENT 2  // 0-100 %, nebo dynamicky nastavováno v aplikaci

typedef enum
{
    NOTE_SILENT = 0,  // pauza

    // Oktáva 4
    NOTE_C4,  NOTE_CS4, NOTE_D4,  NOTE_DS4, NOTE_E4,  NOTE_F4,  NOTE_FS4,
    NOTE_G4,  NOTE_GS4, NOTE_A4,  NOTE_AS4, NOTE_B4,

    // Oktáva 5
    NOTE_C5,  NOTE_CS5, NOTE_D5,  NOTE_DS5, NOTE_E5,  NOTE_F5,  NOTE_FS5,
    NOTE_G5,  NOTE_GS5, NOTE_A5,  NOTE_AS5, NOTE_B5,

    // Oktáva 6
    NOTE_C6,  NOTE_CS6, NOTE_D6,  NOTE_DS6, NOTE_E6,  NOTE_F6,  NOTE_FS6,
    NOTE_G6,  NOTE_GS6, NOTE_A6,  NOTE_AS6, NOTE_B6,

    // Oktáva 7
    NOTE_C7,  NOTE_CS7, NOTE_D7,  NOTE_DS7, NOTE_E7,  NOTE_F7,  NOTE_FS7,
    NOTE_G7,  NOTE_GS7, NOTE_A7,  NOTE_AS7, NOTE_B7,

    NOTE_COUNT
} note_t;

typedef enum
{
    BEEP_CMD_OFF = 0,
    BEEP_CMD_ON,
    BEEP_SHORT_PRESS,
    BEEP_LONG_PRESS,
    BEEP_CMD_SYSTEM_ON,
    BEEP_CMD_SYSTEM_OFF,
    BEEP_TONE_ZONE1,
    BEEP_TONE_ZONE2,
    BEEP_TONE_ZONE3,
    BEEP_TONE_ZONE4,
    BEEP_TONE_ZONE5,
    BEEP_TONE_ZONE6,
    BEEP_TONE_ZONE7,

    BEEP_CMD_COUNT
   
} beep_cmd_t;

typedef struct
{
    beep_cmd_t cmd;
    note_t note;              // použitý u BEEP_CMD_ON
    uint32_t repeat_count;    // počet opakování pro patterny (0 = 1x, 0xFFFFFFFF = nekonečno)
    bool wait_for_previous;   // true: čekej na předchozí pattern, false: přeruš ihned
} beep_msg_t;

void TaskBeep_Start(void);
int TaskBeep_SendCommand(const beep_msg_t *msg);

#endif // TASK_BEEP_H
