#pragma once

#include <zephyr/kernel.h>
#include <stdbool.h>
#include <stdint.h>

// Eventy, které se mohou v systému stát (z buttonu, timeouty, ...).
typedef enum {
    MAIN_EVENT_BTN_PRESSED_EDGE,
    MAIN_EVENT_BTN_RELEASED,
    MAIN_EVENT_BTN_SHORT_PRESS,
    MAIN_EVENT_BTN_LONG_PRESS,
    MAIN_EVENT_BTN_EXTRA,
    MAIN_EVENT_BTN_LONGEST,
    // případně i další eventy z jiných periferií
} main_event_type_t;


typedef struct {
    main_event_type_t type;
    uint32_t param; // Můžeš použít např. index tlačítka, kód RF příkazu, atd.
} main_event_t;


typedef enum {
    SYSTEM_STATE_OFF,
    SYSTEM_STATE_ON,
    SYSTEM_STATE_ERROR,
} SystemState_t;

typedef struct TaskMain_ctx {
    SystemState_t state;
} TaskMain_ctx_t;



void TaskMain_Start(void);
int TaskMain_PutEvent(const main_event_t *evt);
